<?php
/*
 * ARI Orbit Slider
 *
 * @package		ARI Orbit Slider
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2010 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('OrbitSlider.Lightbox.LightboxEngine');

class RokboxOrbitSliderEngine extends AriOrbitSliderLightboxEngine 
{
	function preCheck()
	{
		$version = new JVersion();
		$j15 = version_compare($version->getShortVersion(), '1.6.0', '<');
		$plgPath = JPATH_ROOT . DS . 'plugins' . DS . 'system' . DS . (!$j15 ? 'rokbox' . DS : '') . 'rokbox.php';
		if (!@file_exists($plgPath))
		{
			$mainframe =& JFactory::getApplication();

			$mainframe->enqueueMessage('<b>ARI Orbit Slider</b>: "System - RokBox" plugin isn\'t installed.');
			
			return false;
		}
		
		return true;
	}
	
	function modifyAttrs($lnkAttrs, $imgAttrs, $group, $params)
	{
		$width = intval($params->get('lightbox_width'), 10);
		$height = intval($params->get('lightbox_height'), 10);
		
		$lnkAttrs['rel'] = 'rokbox';
		if ($width > 0 || $height > 0)
			$lnkAttrs['rel'] .= sprintf('[%d %d]',
				$width,
				$height);
			
		if ($group)
			$lnkAttrs['rel'] .= '(' . $group . ')';

		return parent::modifyAttrs($lnkAttrs, $imgAttrs, $group, $params);
	}
}
?>